/***************************************************************************
                          kallery_def.h  -  description
                             -------------------
    begin                : Mon Oct 22 2001
    copyright            : (C) 2001 by Mantia Andras
    email                : amantia@freemail.hu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef KALLERY_DEF_H
#define KALLERY_DEF_H

#include <qstring.h>
#include <qstringlist.h>
#include <qcolor.h>
#include <qtextstream.h>

enum ThumbSettings
{
  NoThumbnails = 0,
  GenerateThumbnails,
  LoadThumbnails
};

enum DescSettings
{
  NoDescriptions = 0,
  UseFilename,
  LoadDescriptions,
  EnterDescriptions
};

enum ConvertMode
{
  NoCopyConvert = 0,
  CopyOnly,
  Convert
};

typedef struct OptionType
{
  QString galleryTitle;
  QString galleryFile;
  QStringList imageList;
  QStringList thumbList;
  QStringList descList;
  QString descFile;
  QString imageDestDir;
  QString thumbDestDir;
  bool relativePaths;
  ThumbSettings thumbSetting;
  DescSettings descSetting;

  ConvertMode convertImages;
  bool resize;
  bool keepRatio;
  bool onlyLarger;
  uint thumbWidth,thumbHeight;
  uint fullWidth,fullHeight;
  QString fullFormat;
  QString thumbFormat;
  uint quality;
  bool insertCopyright;
  QString copyright;

  int columnNum;
  bool useHtmlImages;
  //These option are valid only if UseHtmlImages is TRUE
  bool textButtons;     //if FALSE, then use pictures for buttons
  QString nextStr;      //Valid if TextButtons == TRUE
  QString prevStr;      //Valid if TextButtons == TRUE
  QString backStr;      //Valid if TextButtons == TRUE
  QString nextPic;      //Name of the Next picture. Valid if TextButtons == FALSE
  QString prevPic;      //Name of the Previous picture. Valid if TextButtons == FALSE
  QString backPic;      //Name of the Back picture. Valid if TextButtons == FALSE
  QColor imageBackColor;
  QColor imageTextColor;
  // End of options, when UseHtmlImages is TRUE
  QColor backColor;
  QColor tableColor;
  QColor textColor;
  QString galleryCSSFile;
  QString beforeHtmlFile;
  QString afterHtmlFile;
  QString imageCSSFile;

  // Template options
  QString galleryTemplate;        //The description of the current gallery template. This is saved
  QString fullsizeTemplate;       //The description of the current fullsize template. This is saved
  QString fullsizeTemplateFile;   //The path and name to the template file used for html
                                  //generation for each image
  QString galleryTemplateFile;    //The path and name of the gallery template file
  QString language;
  QString encoding;
  bool  useFrames;

  QString projectFileName;        //The name of the original project
  QString fileName;               //The name of the current file
  bool generatedProject;
};

#endif //KALLERY_DEF_H    
